#ifndef WIN02_HOME_H
#define WIN02_HOME_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include <QTime>
#include <QDate>
#include "guidefs.h"
#include "datei.h"
#include "globVars.h"


class T_win02 : public QWidget
{
    Q_OBJECT

    QGridLayout *myLayout;
    hwinf *HWaccess;
    void updateGui(void);
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *labMaNu1, *labMaNu2;
    QLabel *lab3;
    QTimer *myTO;

    QLabel *labState;
    QLabel *labLoc1, *labLoc2;
    QLabel *labTimeDate;
    QLabel *labZone, *labBez;

    QPushButton *pb1;
    QPushButton *pb2;
    QPushButton *pb3;
    QPushButton *pb4;
    QPushButton *pb5;
    QPushButton *pb6;
    QPushButton *pb7;
    QPushButton *pb8;
    QPushButton *pb9;
    QPushButton *pb10;
    QPushButton *pb11;
    QPushButton *AutSendButton;

    void SysDiag(void);
    void sysPowerOnDiag_ISR(void);
    uint8_t sub_componentAssessment(void);
    uint8_t sys_superviseSystem(void);
    uint8_t sys_getSystemErrors(void);


    QTimer *systemStartUpTimer;
    QTimer *systemSupervisionTimer;
    int sysStartupStep;
    int sysVendingNow;

    QTime *systTime;
    QDate *systDate;

    QLabel *labUID;


    //QLabel *movingTest;
    //QString moveTestStr;
    QPlainTextEdit *pt_loc;


public:
    explicit T_win02(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win02();

private slots:
//    void sysSuper_ISR(void);


public slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void ButtonPb1Clicked(void);
    void ButtonPb2Clicked(void);
    void ButtonPb3Clicked(void);
    void ButtonPb4Clicked(void);
    void ButtonPb5Clicked(void);
    void ButtonPb6Clicked(void);
    void ButtonPb7Clicked(void);
    void ButtonPb8Clicked(void);
    void ButtonPb9Clicked(void);
    void ButtonPb10Clicked(void);
    void ButtonPb11Clicked(void);
    void callAutoSend(void);

signals:
    void quitMyApp(void);


};

#endif
