#ifndef WIN04_STAT_H
#define WIN04_STAT_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "guidefs.h"

class T_win04 : public QWidget
{
    Q_OBJECT

    QGridLayout *myLayout;
    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;
    QLabel *lab3;
    QLabel *lab4;
    QLabel *lab5;
    QTimer *myTO;

    QPushButton *pb_refresh;

    QListWidget *win4_showErrors;
    QListWidget *win4_devParameters;
    QListWidget *win4_showDeviceState;
    QListWidget *win4_showMachineState;

    void entryDevState(QString label, uint8_t val);
    void entryMachineCond(QString label, uint32_t val);
    void entryArray(QString label, uint8_t *buff);

    uint8_t sub_componentAssessment(void);
    uint8_t sys_getSystemErrors(void);


public:
    explicit T_win04(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win04();

public slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void ButtonRefreshClicked(void);

};

#endif
