#ifndef WIN07_COIN_H
#define WIN07_COIN_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "guidefs.h"

class T_win07 : public QWidget
{
    Q_OBJECT

    QGridLayout *myLayout;
    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;
    QLabel *lab3;
    QTimer *myTO;

    QLabel *labMdbPowDev;
    QLabel *labMdbPowBus;
    QLabel *labMdbWakIn;
    QLabel *labRejSw;
    QLabel *labBlockFree;
    QLabel *labSlotPower;
    QLabel *labEscrowSw;
    QLabel *labBarOpen;
    QLabel *labBarOk;

    QPushButton *shut_PB1;
    QPushButton *shut_PB2;
    QPushButton *Led_PB17;
    QPushButton *pb_ledas;
    QPushButton *pb_relay;






public:
    explicit T_win07(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win07();

private slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void pbMdbPow(void);
    void pbMdbWak(void);
    void pbRejectTurn(void);
    void pbShutOpen(void);
    void pbShut3s(void);
    void pbLEDclicked(void);
    void pbEscrowTake(void);
    void pbEscrowRet(void);
    void pbRELclicked(void);

};

#endif
