#ifndef WIN14_MW_H
#define WIN14_MW_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "guidefs.h"

class T_win14 : public QWidget
{
    Q_OBJECT

    //QGridLayout *myLayout;
    QHBoxLayout *myH0layer, *myH1layer, *myH2layer, *myH3layer, *myH4layer;
    QHBoxLayout *myH5layer, *myH6layer, *myH7layer;
    QVBoxLayout *myVmainlayer, *myVlayer_left;
    QVBoxLayout *myVlayer_midd;
    QVBoxLayout *myVlayer_right;

    QHBoxLayout *myHmainlayer;
    QVBoxLayout *myV1mainlayer, *myV2mainlayer;

    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;

    QTimer *myTO;
    //QPushButton *pB1, *pB2, *pB3, *pB4, *pB5, *pB6, *pB7, *pB8;
    QLabel *lab20, *lab21, *lab22, *lab23, *lab24, *lab25;
    QLabel *lab30, *lab31, *lab32, *lab33, *lab34, *lab35;
    QLabel *lab41, *lab43, *insertedCoin, *showChangeRes;
    QLabel *labTotalContent;

    //QTextEdit *showStatics;
    QTextEdit *showDynamics;
    QPushButton *pb_stopPay, *pb_vendSucc;
    QPushButton *pb_startPay;
    QPushButton *pb_powerOn, *pb_giveChange, *pb_giveAll;

    bool fl_payStarted;
    bool fl_storeStartVal;
    bool fl_displayLevel;

    uint8_t mw_BeginLevel[8];
    int diffLevel[8];
    long diffAmount;
    uint32_t totalContent;

public:
    explicit T_win14(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win14();

public slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void slot_powerOn(void);
    void ButtonStartClicked();
    void ButtonStopClicked(void);
    void ButtonSuccClicked(void);
    void slot_giveChange(void);
    void slot_giveAll(void);

    void signalGotNewCoin();
    void signalJustStarted();
    void signalCollectAbort();
    void signalStopByMax();
    void signalStopByUser();
    void signalStopByEscrow();
    void signalStopByError();
    void signalStopTO()       ;
    void signalCancelled() ;
    void signalProcessStop();

/*
    void slot_pb3(void);
    void slot_pb4(void);
    void slot_pb5(void);
    void slot_pb6(void);
    void slot_pb8(void);
*/


};

#endif
